#include <math.h>
#include <qglobal.h>
#include <ctype.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <time.h>
#include <qimage.h>
#include <semaphore.h>
#include "drawmap.h"

#if UINT_MAX == 65535
typedef long            GInt32;
typedef unsigned long   GUInt32;
#else
typedef int             GInt32;
typedef unsigned int    GUInt32;
#endif

typedef short           GInt16;
typedef unsigned short  GUInt16;
typedef unsigned char   GByte;
typedef int             GBool;
#define WORD unsigned short
#define DWORD unsigned long

extern sem_t sem_ksr;
extern sem_t sem_shm;

double longitude,lattitude;
double lattitudeCenterFullMap=0;
double longitudeCenterFullMap=0;
double lattitudeCenterShowMap=0;
double longitudeCenterShowMap=0;
double cellSizeY=0;
double cellSizeX=0;

extern int fl;
double xp=0;
double yp=0;
int nvxp=0;
int nvyp=0;
int imf=0;
int ims=0;

int classes[4]= {13,69,71,114};
int sizeFullMap=4;
extern int mapSize;
extern int mapState;
double minCutoffShowMap= 10;
double minCutoffFullMap=0.1;
double minCompilation=10000;
double maxCompilation=400000;




QImage qimFullMap(2*Height,2*Height,8,128);
QImage qimShowMap(Height,Height,8,128);



int msDrawLinkor( char * mapfile , char * outfile, double * extent, unsigned char * mem,int status,
void *& pimage, void *& pmap,QImage *qim);
double pi=3.141592653589793;
double radius   = 6371;
void reckon(double lat,double lon,double az,double rng,double & latout,double & lonout );
int nRequest=0;
extern pthread_t server16;// 
double minX=0;
double minY=0;
double maxX=0;
double maxY=0;
int  WriteFile(char *filename,unsigned char *pszBuffer,int  nLength);

unsigned char  buf1[620];
unsigned char  buf2[612];
unsigned char  Buf[2097152];
unsigned char  BufEn[2097152];
int nMaxLength;
int TermKSRSoc=0;
int sksr;
long timemap=0;
int mgo=0;
int nMoveShip=0;

void NANOSON()
{
    struct timespec req = {0, 15};
    nanosleep(&req, 0);
}
int INI_KSRSocket(){
           	int rc;
	qDebug("INIT_KSR");
	struct sockaddr_in peer;
           	memset(&peer,0,sizeof(peer));
	peer.sin_family = AF_INET;
	peer.sin_port = htons( 2506);
	peer.sin_addr.s_addr =inet_addr("192.168.1.25");//192.168.2.25

	sksr = socket ( AF_INET, SOCK_STREAM, 0 ); 
	if(sksr==-1){return -1;}

	int yes = 1;
	rc = setsockopt(sksr, IPPROTO_TCP, TCP_NODELAY, (unsigned char *) &yes, sizeof(yes));
	
	rc = connect( sksr, ( struct sockaddr * )&peer, sizeof( peer ) );
	if(rc!=0){return -1;}

	qDebug("INIT_KSR[%d, %d]", sksr, rc);
	return sksr;
}// INI_KSRSocket

int	DEINI_KSRSocket()
{
	shutdown(sksr,2);
	close (sksr);
	qDebug( "CLOSE KSR SOCKET");
	return 0;
}


void ExportCompilationToBinary(double x,const unsigned char *pszTarget)
{
	unsigned long *coord = (unsigned long*)(pszTarget);
	*coord = htonl((unsigned long)(x));
	
}

//  ExportAngleToBinary
void ExportAngleToBinary(double x,const unsigned char *pszTarget)
{
 	double precision=(2<<13)/180.0;
	unsigned short *coord = (unsigned short*)(pszTarget);
	*coord++ = htons((unsigned short)(x*precision));
	
}
unsigned char * ExtractStringData( const unsigned char * pachSourceData,
                                    int nMaxBytes )

{
   int         nLength = nMaxBytes;

/* -------------------------------------------------------------------- */
/*      Do we need to grow the buffer.                                  */
/* -------------------------------------------------------------------- */
   
        
   int nMaxBufChars = nLength+1;
   unsigned char * pachBuffer = (unsigned char *) malloc(nMaxBufChars);
    

/* -------------------------------------------------------------------- */
/*      Copy the data to the buffer.  We use memcpy() so that it        */
/*      will work for binary data.                                      */
/* -------------------------------------------------------------------- */
    memcpy( pachBuffer, pachSourceData, nLength );
    pachBuffer[nLength] = '\0';

    return pachBuffer;
}

int SendIP1RequestForListENC(unsigned char * pSendRequest1,int & nRequest,int nClasses,int * classes)
{
	        
		
		int totalw=0;

	    nRequest++;
		if(nRequest > 255)
			nRequest=0;
//  prepare 1 request 
		     
		pSendRequest1[0]=(unsigned char)nRequest;
       	pSendRequest1[1]=9;
		double precision=(2<<13)/180.0;
		unsigned short *coord = (WORD*)(pSendRequest1+2);
	  	*coord++ = htons((WORD)(minX*precision));
		*coord++ = htons((WORD)(minY*precision));
		*coord++ = htons((WORD)(maxX*precision));
		*coord++  = htons((WORD)(maxY*precision));
         printf("Margin Picture %f   %f  %f  %f  \n",minX,minY,maxX,maxY); 
       // double precision2=180.0/(2<<13);
       // WORD test=htons((WORD)(-32.516556*precision));
       // double tX=precision2*(signed short)ntohs(test);
       // printf("Compare -32.516556 %f  %d \n",tX,2<<13);                
                         
	    unsigned long l1 = htonl((DWORD)(minCompilation));
        *coord++=l1 >> 16;
        *coord++=l1&0xFFFFFFFF;
        unsigned long l2= htonl((DWORD)(maxCompilation));
        *coord++=(WORD)(l2 >> 16);
        *coord=(WORD)(l2&0xFFFFFFFF);
        WORD *w= (WORD *)(pSendRequest1+2*5+2*4);
                           
		*w++=htons(nClasses);
            
		for(int i=0; i <  nClasses;i++)
		{
		   *w++=htons(classes[i]);
		}
	
		int np1=2*5+2*4+2+2*nClasses;
// send 1 request
		int Pr_KSR=1;
		
		while(Pr_KSR != 0)
        {
			qDebug("Sending list enc  np1 %d \n",np1);
                             
            int rc = send( sksr,pSendRequest1+totalw,np1-totalw, MSG_DONTWAIT );
                                 printf("Send  1  %d \n",rc);
			if ( rc < 0 ){	
				return 0;
	
			}// if rc<0
			else if ( rc == 0)
			{
				Pr_KSR=0;
			   				return 0;

			}//else if rc==0
			else if ( rc > 0 ){
				totalw += rc; 				
				if ( totalw == np1 ){
					Pr_KSR=0;
					totalw=0;
							
				}//if ( totalw == np1 )
			};//if ( rc > 0 )
         }//if(Pr_PSR==1)

	       
                     
		
		return 1;
}



int SendIP1RequestForOneENC(unsigned char * strENC,unsigned char * pSendRequest2,int & nRequest,int nClasses,int * classes)
{
	     
		
        nRequest++;
		if(nRequest > 255)
			nRequest=0;
	    // 2 request
		pSendRequest2[0]=(unsigned char)nRequest;
       	pSendRequest2[1]=(1<<4)|9;
		strncpy((char *)(pSendRequest2+2),(char *)strENC,8);

		unsigned short *w= (unsigned short *)(pSendRequest2+2+8);
		*w++=htons(nClasses);
		for(int i=0; i <  nClasses;i++)
		{
		   *w++=htons(classes[i]);
		}
        qDebug("Name sending ENC %s \n",strENC);
        
        int np2=2+8+2+2*nClasses;
		int Pr_KSR=1;
		int totalw=0;
		while(Pr_KSR!=0)
        {
			qDebug("send for one enc  \n");
		//	WriteFile("RQENK.PRT",pSendRequest2,np2);
            int rc = send( sksr,pSendRequest2+totalw,np2-totalw, MSG_DONTWAIT );
			qDebug("send for one enc %d  np2 %d \n",rc,np2);
			if ( rc < 0 )
            {
				return 0;
	
			}// if rc<0
			else if ( rc == 0)	{
				Pr_KSR=0;
  				return 0;

			}//else if rc==0
			else if ( rc > 0 ){ 
				totalw += rc; 					
				if ( totalw == np2){
					Pr_KSR=0;
					totalw=0;
							
				}//if ( totalw == np2 )
			};//if ( rc > 0 )
         }//if(Pr_KSR==1)



		return 1;

}
int  WriteFile(char *filename,unsigned char *pszBuffer,int  nLength)
{
  
  FILE *stream;
  int	 ret=1;
 
  
  if(filename != NULL && strlen((char*)filename) > 0) {
      stream = fopen((char *)filename, "w");
      if(!stream) {
        
          return 0;
      }
  }
  else
  {
     
      return 0;
  }

  
  
  fwrite( pszBuffer, nLength, 1, stream ); 
 

  fclose( stream );

  return ret;
}

// form new image
int FormImage(unsigned char * Buf,unsigned char * pSendRequest,int & nRequest, int nClasses,int * classes,int nMaxLength)
{
	    int hh=0;
        hh=1;
              
		WORD *w = (WORD*)(Buf+6);
		int EMQ=(int)(w[0] << 16|+ w[1]);
		
		qDebug("map number %d /n",EMQ);
		printf("map number %d /n",EMQ);

		void * pmap=0;
		void * pimage=0;

		double extent[4];

		extent[0]=minY;
		extent[1]=minX;
		extent[2]=maxY;
		extent[3]=maxX;
                    
		int ret=1;
        int nNext=1;
        int nj=0;
	    int j=0;
		
		for(int i=0;i < EMQ;i++)
		{

		    int status=0;
			unsigned char* strENC  =ExtractStringData( Buf+5*2+i*14*2,8);
			printf("map object %s/n",strENC);
			int re= SendIP1RequestForOneENC(strENC,pSendRequest,nRequest,nClasses,classes);
              
	      		  free(strENC);
			if(re <=0)
                                 {
				ret=0;
				goto finish;
                                  }

            do
			{   

			    int nMax=0;
                int totalr=0;
			    int ipr2=1;
			    int ipr10=1;

                int PRI=1;
			    while(PRI)
                {
                                   
					int re = recv( sksr,BufEn+totalr,nMaxLength-totalr, 0/*MSG_WAITALL | MSG_NOSIGNAL*/ );
					if (re <= 0) 
					{
						qDebug("error receive <= 0");
						ret= 0;
						goto finish;
					}
         			else
					{
						totalr+=re;
					if(totalr >=2)
					{
					
						int nByte2=(int)BufEn[0];
						int Prip=nByte2 & 0x3;
						int nNsp =(nByte2 >>2) & 0x1;
						int nKoP  =(nByte2 >> 3)&0xF;
						int nRequest1=(int)BufEn[1];
						if(ipr2)
						{
							qDebug("Prip %d  nNsp %d  nKop %d  nRequest1 %d /n",Prip,nNsp,nKoP, nRequest1);
							ipr2=0;
						}

					
				          
						if(Prip==3)
						{
							WORD *w = (WORD*)(BufEn+2);
		         			ret=(int)ntohs(*w);
							ret=0;
							goto finish;
						
						}
					}
 					if(totalr >= 11)
					{
						nNext=BufEn[5*2];
					}
					if(totalr> 10)
					{

                         if(ipr10)
					     {
                            				           w = (WORD*)(BufEn+6);
					   		nMax=(int)(w[0] << 16|+ w[1]);

	
                            qDebug("Receive map nMax %d /n",nMax );
		      printf("Receive map nMax %d /n",nMax );
                            ipr10=0;
					      }

					
						if(nMax ==totalr)
						  PRI=0;
		
					}
                }
             }
		
			 if(nj==0)
			 {
				status=1;
				if(i+1==EMQ && nNext==0 )
					status|=4;
			 }
			 else
			 {
				 if(i+1==EMQ && nNext==0 )
					status=4;
				 else
				    status=2;
					  
		      }
		      j=j+1;
                            char nameg[100];
    		     sprintf(nameg,"LK.PR%d",j);
        
		      WriteFile(nameg,BufEn,nMax);
		      msDrawLinkor("linkor.map", 0, extent,( unsigned char *)BufEn,status,pmap,pimage,&qimFullMap);
                                   
		      nj++;
         }
		 while(nNext!=0 && nj < 6);
		
		}
        qDebug("Finish  map /n" );
        printf("Finish  map /n" );
        imf++;
        ims=0;
        char namet[100];
        sprintf(namet,"t%dm.png",imf);
        
        
       // qimFullMap.save(namet,"PNG");
      
       
finish:
		return ret;
}
// 
void DrawShowMap()
{
          double distX =(maxX-minX)/4.0;
          double distY =(maxY-minY)/4.0;
          // double dist= distX < distY?distX:distY;

          xp=(longitudeCenterShowMap-minY-distY)/cellSizeX;
          yp=(-lattitudeCenterShowMap+maxX-distX)/cellSizeY;
          double xpl=(longitude-minY-distY)/cellSizeX;
          double ypl=(-lattitude+maxX-distX)/cellSizeY;
 
          int nxp= (int)xp; int nyp= (int)yp;
          int nxpl= (int)xpl; int nypl= (int)ypl;
 
           
          if(nxp < 0) nxp=0;
          if(nyp < 0) nyp=0;
          if(nxp >= Height) nxp=Height-1;
          if(nyp >= Height) nyp=Height-1;

          if(nxpl < 0) nxpl=0;
          if(nypl < 0) nypl=0;
          if(nxpl >= Height) nxpl=Height-1;
          if(nypl >= Height) nypl=Height-1;



          nvxp=nxpl-nxp; nvyp=nypl-nyp;
          if(abs(nvxp) > 62 /*125*/ || abs(nvyp) > 62  /*125*/|| (nvxp==0 && nvyp==0)) 
          {
          		 lattitudeCenterShowMap= lattitude;longitudeCenterShowMap=longitude;
         		 nvxp=0;nvyp=0;
          if(fl==0)
		 		 qimShowMap=qimFullMap.copy(nxpl,nypl,Height,Height,0);
          }
          char namet[100];
          sprintf(namet,"t%dm%d.png",imf,ims);
		  qDebug("xp %f yp %f \n",(longitudeCenterShowMap-minY)/cellSizeY,(lattitudeCenterShowMap-minX)/cellSizeX);
          qDebug("xp %f yp %f name %s \n",xp,yp,namet);


          ims++;
          fl=1;
          mgo=0;

}
//
void* server_16(void*)

{
   try
   {
	int re;
	
    int totalr=0;
	nMaxLength=2097152;
    int nClasses=sizeof(classes)/4;

	

       
	int EMS=0;
    int first=1;

    INI_KSRSocket();
	
	while(!TermKSRSoc)
    {

	int Pr_Ks=1;
   //qDebug(" Wait coordinates");    
    sem_wait(&sem_ksr);
   // printf(" mapSize %d mapState %d \n",mapSize,mapState);
    if(mapSize==0 && mapState==0)
    {
         mgo=0;
         continue;
    }
   // qDebug(" lat %f lon % f  latcfm %f     loncfm %f ",lattitude,longitude,lattitudeCenterFullMap,longitudeCenterFullMap);
   // printf(" lat %f lon % f  latcfm %f     loncfm %f \n",lattitude,longitude,lattitudeCenterFullMap,longitudeCenterFullMap);
 //   if(mapSize!=sizeFullMap)
  //     printf(" mapSize %d sizeFullMap",mapSize,sizeFullMap);
	if( xp >=0 && yp >=0 && xp <= Height && yp <= Height  && !first&& mapSize==sizeFullMap)
	{ 
		//qDebug(" latCSM %f lonCSM % f \n",lattitudeCenterShowMap,longitudeCenterShowMap);
	    DrawShowMap();
 		continue;
    }
    if(mapState==0 &&  mapSize!=0)
    	sizeFullMap=mapSize;
    lattitudeCenterFullMap= lattitude;longitudeCenterFullMap=longitude;
    lattitudeCenterShowMap= lattitude;longitudeCenterShowMap=longitude;
       
    double latout,lonout;
	double rad=sizeFullMap/radius;
	double rng=rad*180/pi;

    if(/*first*/1==1)
    {
		/*
                     double dd=((pi*radius)/180)*rng;
                      maxX=lattitudeCenterFullMap+dd;
                      minX=lattitudeCenterFullMap-dd;
 	           maxY=longitudeCenterFullMap+dd;
                      minY=longitudeCenterFullMap-dd;
                    */
		//double lat1,lon1;
		//reckon(56.0,-157.0,90,0.1,lat1,lon1 );
		
		reckon(lattitudeCenterFullMap,longitudeCenterFullMap,0,rng,maxX,lonout );
		reckon(lattitudeCenterFullMap,longitudeCenterFullMap,90,rng,latout,maxY );
		reckon(lattitudeCenterFullMap,longitudeCenterFullMap,180,rng,minX,lonout );
		reckon(lattitudeCenterFullMap,longitudeCenterFullMap,270,rng,latout,minY);
                    
        
    }
    else
    {

        double dx=(maxX-minX)/2.0;
        minX=lattitudeCenterFullMap-dx; 
        maxX=lattitudeCenterFullMap+dx; 
        
        minY=longitudeCenterFullMap-dx; 
        maxY=longitudeCenterFullMap+dx; 


    }
     first=0;

   
    double distX =(maxX-minX);
    double distY =(maxY-minY);
    double dis;
    if(distX < distY)
    {   
       dis=distX/2;
       minY=longitudeCenterFullMap-dis;
       maxY=longitudeCenterFullMap+dis;

    }
    else
    {
       dis=distY/2;
       minX=lattitudeCenterFullMap-dis;
       maxX=lattitudeCenterFullMap+dis;


    }
    cellSizeX=(maxX-minX)/(2*Height);
    cellSizeY=(maxY-minY)/(2*Height);

	int ret=SendIP1RequestForListENC(buf1,nRequest,nClasses,classes);

	if(ret <= 0)
		goto finish;
  	while(Pr_Ks)
	{

        re = recv( sksr,Buf+totalr,nMaxLength-totalr,0 /* MSG_WAITALL | MSG_NOSIGNAL*/ );
	printf("receive lst  1 %d \n",re);
		if (re < 0) 
		{

			/*
			if(timemap==0){ timemap=time1;	}
		           else if((time1-timemap)>=30){ 
			   	KSR_ITS_O=false; 
				timemap=0; 
				DEINI_KSRSocket();
				INI_KSRSocket();
		           }
			else
		           */	
			goto finish;
		
		}
	    else if (re == 0) 
		{
					//  ->   !!!
			/*if(timemap==0){ timemap=time1; }
			else if((time1-timemap)>=30)
				{ 
				KSR_ITS_O=false; 
				timemap=0;
				DEINI_KSRSocket();
				INI_KSRSocket();
				}
			else*/
			  goto finish;
			
		}
		else if ( re> 0 )
		{
	
			totalr += re;
			if(totalr >=3)
            {
 				int nByte2=(int)Buf[0];
				int Prip=nByte2 & 0x3;
                qDebug("receive totalr   1 %d \n",totalr);
				if(Prip==3)
				{
					  WORD *w = (WORD*)(Buf+2);
		 			  ret=(int)ntohs(*w);
					goto baddata;
                }
             }
                               
					
			if(totalr >= 6)
			{
				qDebug("totalr   2 %d \n",totalr);	
				WORD *w = (WORD*)(Buf+2);
				long dw=(long)(w[0] << 16|+ w[1]);
		   		EMS=(int)ntohl(dw);
 				
				if ( totalr == EMS )

				{
					qDebug("EMS    %d \n",EMS);	
					totalr=0;
				    Pr_Ks=0;
                   	timemap=0;
					qDebug( "packet 1 received");
					printf( "packet 1 received\n");
				}
				
				
			}
            else continue;
		};//if ( re > 0 )
     }
	         
            
     qDebug("Preparing for sending map \n");
     printf("Preparing for sending map \n");
     try
     {
    	 re= FormImage(Buf,buf2,nRequest, nClasses,classes,nMaxLength);
	     DrawShowMap();
     }
     catch(...)
     {
		 qDebug( "error in drawing\n");

     }
     NANOSON();
      if(mapState==1)
      {
         mapState=0;
         mgo=0;
         fl=1;

      }

     continue;
     baddata:
  			first=1;
                              fl=1;
          		    mgo=0;
            continue;
     finish:
		   printf("Socket error list enc\n");
                          DEINI_KSRSocket();
		    INI_KSRSocket();
                           first=1;
                              fl=1;
          		    mgo=0;
     

     }
                       
         	
  	DEINI_KSRSocket();
    pthread_exit(0); 
   }
  catch(...)
  {
	qDebug( "error in server16\n");
    printf("error in server16\n");


  }
	
}

//  ExportCom

double  wrapnpi2pi(double u)
{
// Wrap an angle U (in radians) to the interval [-pi pi].  Equivalent to
// w = npi2pi(u,'radians')
	double sign = u >= 0? 1.0:-1;
	double cs =ceil(((fabs(u)/pi)-1.0)/2.0);
	double ret= pi*((fabs(u)/pi) - 2.0*cs) * sign;
	return ret;
}
void rhspherefwd(double phi0, double lambda0,double  alpha,double  s, double radius,double & phi,double & lambda)
{ 
// Forward rhumbline problem on a sphere.
 
//Specify a cutoff value:  If cos(ALPHA) > cutoff, use a formula for
// longitude that is exact but undefined for small cos(ALPHA). Otherwise,
// use an approximation that is both accurate and stable for very small
// cos(ALPHA).  The specific cutoff value used here is optimal in the sense
//that it leads to roughly errors (less than 1e-10 radians in longitude,
//negligible in latitude) with both methods

double cutoff = 0.00001;
int q = (fabs(cos(alpha)) > cutoff)? 1:0;
 
double cosalpha = cos(alpha);
double sinalpha = sin(alpha);
 
s = s / radius;  // Normalize to unit sphere
 
phi = phi0 + s * cosalpha;

//lambda = zeros(size(phi0));
 
if(q)
{
   double psi =  log(tan(phi/2  + pi/4));
   double psi0 = log(tan(phi0/2 + pi/4));
   lambda = lambda0 + (sinalpha/cosalpha) * (psi - psi0);
}
else
   lambda = lambda0 + (sinalpha/cos(phi0)) * s;


}
//function [phi, lambda] = rhumblinefwd(phi0, lambda0, alpha, s, in5)
void rhumblinefwd(double phi0, double lambda0,double  alpha,double  s, double radius,double & phi,double & lambda)
//RHUMBLINEFWD Forward rhumbline problem on a sphere or ellipsoid.

{

if(phi0 >  pi/2) 
		phi0=  pi/2;
if(phi0 < -pi/2) 
		phi0= -pi/2;



rhspherefwd(phi0, lambda0, alpha, s, radius,phi,lambda);


if(phi >  pi/2) 
		phi=  pi/2;
if(phi < -pi/2) 
		phi= -pi/2;
lambda = wrapnpi2pi(lambda);


return;

}

void reckon(double lat,double lon,double az,double rng,double & latout,double & lonout )
{
	    double newlat,newlon;
        lat=lat*pi/180;
		lon=lon*pi/180;
		az=az*pi/180;
		rng=rng*pi/180;


        rhumblinefwd(lat,lon,az,rng,1,newlat,newlon);


		newlon = wrapnpi2pi(newlon);

	


		latout = newlat*180/pi;
		lonout = newlon*180/pi;

		return;


}
