#include <stdio.h>
#include <stdlib.h>
#include "drawmap.h"
#include <qpushbutton.h>
#include <qtimer.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qimage.h>
#include <qtoolbar.h>
#include <qspinbox.h>
#include <qlabel.h>
#include <semaphore.h>
#include <qtextcodec.h>
#include <qpushbutton.h>
extern sem_t sem_shm;
extern QImage qimShowMap;
extern QImage qimFullMap;
extern int nxp;
extern int nyp;
extern int nvxp;
extern int nvyp;
extern double longitude,lattitude;
extern double cellSizeY;
extern double cellSizeX;
int mapSize=0;
int mapState=0;
extern  double pi;
extern  double radius;
extern int fl;
int init=0;
#define Center Height/2
//QPixmap pm;





/*
   Starts a 1000 ms animation timer.
*/
DrawMap::DrawMap(QWidget *parent, const char *name, WFlags flags) 
    :   QMainWindow(parent, name, flags) 

{
   	QTextCodec *codec = QTextCodec::codecForName("CP1251");
	QTextCodec::setCodecForTr(codec);
	QTextCodec::setCodecForCStrings(codec);
	QTextCodec::setCodecForLocale(codec);
     //  resize( 1200, Height);
     QToolBar* controls = new QToolBar(this);
   moveDockWindow(controls,Right);
    (void) new QLabel(tr("Map size (km):"), controls);
        QSpinBox *row = new QSpinBox(0,255,1,controls);
      (void) new QLabel(tr("Lingitude(degree):"), controls);
     qLongitude=   new QLabel(tr("                "), controls);
   (void) new QLabel(tr("Lattitude(degree):"), controls);
     qLattitude=   new QLabel(tr("                "), controls);
    /*
   (void) new QLabel(tr("  X(km):"), controls);
     qLX=   new QLabel(tr("               "), controls);
   (void) new QLabel(tr("  Y(km):"), controls);
     qLY=   new QLabel(tr("                "), controls);
   */

   qChMapShow= new QPushButton(tr("Show Map"),controls);

   connect(qChMapShow,SIGNAL(clicked()),this,SLOT(chMapClicked()));
   connect(row,SIGNAL(valueChanged(int)),this,SLOT(setMapSize(int)));
   row->setValue(0);
   QTimer *timer = new QTimer(this);
   connect( timer, SIGNAL(timeout()), SLOT(animate()) );
   timer->start( 1000);
   setMouseTracking(true);
    int w =row->width();
   resize( Height+w+60, Height);
   setMaximumWidth(Height+w+60);
   setMaximumHeight(Height);
    
}

DrawMap::DrawMap( const char *text, QWidget *parent, const char *name )
    :  QMainWindow(parent,name), t(text), b(0)
{
   QTimer *timer = new QTimer(this);
   connect( timer, SIGNAL(timeout()), SLOT(animate()) );
   timer->start( 1000 );
   setMouseTracking(true);
    resize( Height, Height );
}

void DrawMap::chMapClicked()
{
     mapState=1;
     

}

void DrawMap::setMapSize(int size)
{
     mapSize=size;
   // printf(" New Map size %d",mapSize);

}
void DrawMap::animate()
{
    b = (b + 1) & 15;
  
   //if(fl==1)
    repaint(FALSE );
}


/*
  Handles mouse button release events for the Hello widget.

  We emit the clicked() signal when the mouse is released inside
  the widget.
*/

void DrawMap::mouseReleaseEvent( QMouseEvent *e )
{
  //  if ( rect().contains( e->pos() ) )
    //    emit clicked();
}


/*
  Handles paint events for the Hello widget.

  Flicker-free update. The text is first drawn in the pixmap and the
  pixmap is then blt'ed to the screen.
*/
void DrawMap::mouseMoveEvent( QMouseEvent * e)
{
       if ( rect().contains( e->pos() ) )
       {
	nmx=abs(e->x()-Center);
           nmy=abs(e->y()-Center);
       }
       else
      {
           nmx=0;
	nmy=0;
       }



}
void DrawMap::paintEvent( QPaintEvent * )
{
    // static   QPixmap  pm(Height,Height);
    // pm.convertFromImage(qimShowMap, 0);
     
    //    static   QPoint   point(0,0);
   //static           double * Extent=0;
    void * pmap =0;
    void * pimage=0;
  
    int pmx =qimShowMap.width();
    int pmy = qimShowMap.height();
   // unsigned char * b=  qimShowMap.bits();

   // sem_wait(&sem_shm); 
   if(fl==1 /*&& pmx==Height && pmy==Height*/)
   { 
  


     //pm=qimShowMap;
     //
     // bitBlt( this, 0, 0, &pm );
      QPixmap pm=qimShowMap;

      QPainter painter(&pm);

      
      painter.begin(&pm,this);
      QFont font=painter.font();
      font.setPixelSize(13);
      painter.setFont(font);
      QColor color;
      painter.setPen(red);
      QBrush b3( Qt::blue );
      painter.setBrush(b3); 
      painter.drawEllipse(Center+nvxp,Center+nvyp,3,3);
      painter.setPen(white);
      painter.drawArc(Center+nvxp-Height/8,Center+nvyp-Height/8,2*Height/8,2*Height/8,0,16*360);
      painter.drawArc(Center+nvxp-2*Height/8,Center+nvyp-2*Height/8,4*Height/8,4*Height/8,0,16*360);
      painter.drawArc(Center+nvxp-3*Height/8,Center+nvyp-3*Height/8,6*Height/8,6*Height/8,0,16*360);
      painter.drawArc(Center+nvxp-4*Height/8,Center+nvyp-4*Height/8,8*Height/8,8*Height/8,0,16*360);
    //  painter.drawLine(0,Center,Height,Center);
    // painter.drawLine(Center,0,Center,Height);
     int angle=0;
   // const double pi=3.141592653589793;

     while(angle <360)
     {
            double ug=(pi*angle)/180.0;
	 painter.drawLine(Center+nvxp,Center+nvyp,Center+nvxp+Center*cos(ug),Center+nvyp+Center*sin(ug));
            angle+=30;

      }



      
      double term=(pi*radius)/180.0;
    //  painter.drawImage(0,0,qimShowMap,0,0,-1,-1, OrderedAlphaDither);
      qLattitude->setText(QString("%1").arg(lattitude,9,'f',4));
      qLongitude->setText(QString("%1").arg(longitude,9,'f',4));
      // qLY->setText(QString("%1").arg(nmy*cellSizeY*term,9,'f',2));
     // qLX->setText(QString("%1").arg(nmx*cellSizeX*term,9,'f',2));
     /*
      QString s=
      QString(" Longitude: %1   Lattitude: %2  nvxp %3  nvyp %4").arg(longitude,9,'f',4).arg(lattitude,9,'f',4)
      .arg((nvxp-Center)*cellSizeX+longitude,9,'f',4).arg((nvyp-Center)*cellSizeY+lattitude,9,'f',4);
      painter.drawText(10,960,s);
    */
	
      painter.end();
      
      
      bitBlt(this,0,0,&pm);

 
	 fl=0;
     init=1; 
   
   }

   else if(init==1)
   {
		
	//	bitBlt( this, 0, 0, &pm );


   }

      // fl=0;
 //  } 
  // delete qim;
}
