/****************************************************************************
** $Id: qt/main.cpp   3.3.6   edited Aug 31 2005 $
**
** Copyright (C) 1992-2005 Trolltech AS.  All rights reserved.
**
** This file is part of an example program for Qt.  This example
** program may be used, distributed and modified without limitation.
**
*****************************************************************************/

#include "drawmap.h"
#include <qapplication.h>
#include <qglobal.h>
#include <qplatinumstyle.h>
#include <qfile.h>
#include <signal.h>
#include <unistd.h>
#include <math.h>
#include <ctype.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <pthread.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <unistd.h>
#include <time.h>
#include <qimage.h>
#include <semaphore.h>
#include <qpainter.h> 
#include <qstyle.h> 
#include <qtoolbutton.h> 
#include <qnamespace.h> 
#include <qwidget.h> 

#include "drawmap.h"

extern double longitude;
extern double lattitude;
extern int mgo;



#define CHR_MAX 66 /*  CHARDASH*/
int sakng;


QWidget *mainframe = 0;



sem_t sem_ksr;
sem_t sem_shm;

//QTable *table;
//extern
 QString AppDir;

//terminators
int TermAKNGSoc;
extern int TermKSRSoc;
extern void NANOSON();
int fl =0;
//threads
pthread_t server14;// AKNG
pthread_t server16;// maps


void CreateNetwork(void);

FILE *QD_File;
FILE *Log_File;
void myMessageOutput(QtMsgType type, const char* msg){

     switch (type) {
     case QtDebugMsg:
        // QD_File = fopen("qDebug.txt","a");  
         fprintf(QD_File, "%s\n", msg);
	//	 fclose(QD_File);

         break;
     case QtWarningMsg:
         fprintf(Log_File, "%s\n", msg);
         break;
     case QtFatalMsg:
         fprintf(stderr, "Fatal: %s\n", msg);
         abort();
     }//switch	

}//void myMessageOutpu


/*
  The program starts here. It parses the command line and builds a message
  string to be displayed by the Hello widget.
*/
void CreateNetwork(void)
{
	int rez;
	pthread_attr_t attr1, attr2, attr3, attr4, attr5, attr15, attr6, attr7, attr8, attr9, attr10, attr11, attr12, attr14,attr16;
	pthread_attr_t attrf, attrvsi;

			pthread_attr_init (&attr14);
			pthread_attr_setdetachstate (&attr14, PTHREAD_CREATE_DETACHED); 
			pthread_create(&server14,&attr14,server_14,NULL);
			pthread_attr_destroy (&attr14);
          


			rez=sem_init(&sem_ksr,0,0);
			if (rez!=0) qDebug("NO SEM_KSR");
			rez=sem_init(&sem_shm,0,0);
    		if (rez!=0) qDebug("NO_SEM_SHM");
			pthread_attr_init (&attr16);
			pthread_attr_setdetachstate (&attr16, PTHREAD_CREATE_DETACHED); 
			pthread_create(&server16,&attr16,server_16,NULL);
			pthread_attr_destroy (&attr16);

      
	
    


}
int main( int argc, char **argv )
{
    QApplication a(argc,argv);
    QString s;
    for ( int i=1; i<argc; i++ ) {
	s += argv[i];
	if ( i<argc-1 )
	    s += " ";
    }
    QD_File = fopen("qDebug.txt","w");   
	Log_File = fopen("prog_log.txt","w");   
	qInstallMsgHandler(myMessageOutput);
	qDebug("--------------------Log started--------------------");
    if ( s.isEmpty() )
	s = "Draw Map";
    DrawMap h(0,0,(unsigned int)(Qt::WNoAutoErase));
    QObject::connect( &h, SIGNAL(clicked()), &a, SLOT(quit()) );
 //   h.setFont( QFont("times",32,QFont::Bold) );		// default font
    h.setBackgroundColor( Qt::black );			// default bg color
    a.setMainWidget( &h );
    h.show();
    
	qDebug("Done.\nCreating Network... ");
	CreateNetwork();
    int res= a.exec();
	TermAKNGSoc = 1;
    sem_post(&sem_ksr);
	TermKSRSoc=1;
	//delete pFP;  ????????????
	usleep(100000);
	qDebug("--------------------Log closed--------------------");
	fclose(Log_File);
    fclose(QD_File);
}
int	INI_AKNGSocket()
	{
	int rc;
	struct sockaddr_in peer;
 	memset(&peer,0,sizeof(peer));
	peer.sin_family = AF_INET;
        peer.sin_port = htons( 6100 );//6100//7500
        peer.sin_addr.s_addr =inet_addr("192.168.1.31");//"192.168.1.1"//"127.0.0.1"
	sakng = socket ( AF_INET, SOCK_STREAM, 0 ); 
 	if(sakng==-1) {
		qDebug("NO_INIT_AKNG");
	return -1;
           }

           //alg Neigl disable
	int yes = 1;
	rc = setsockopt(sakng, IPPROTO_TCP, TCP_NODELAY, (char *) &yes, sizeof(yes));

	qDebug("INIT_AKNG[%d, %d]", sakng, rc);	
        rc = connect( sakng, ( struct sockaddr * )&peer, sizeof( peer ) );
			if(rc!=0)
			return -1;
	return 1;

  	}// INI_AKNGSocket

int	DEINI_AKNGSocket()
{
	shutdown(sakng,2);
	close (sakng);
	qDebug("CLOSE AKNG SOCKET");
	return 0;
}
#define Swap(X) (((X & 0xFF)<<8) | ((X & 0xFF00)>>8))
void *server_14(void *)
{
	int rc; 
	int totalr=0;
    char bufakng[1024];
	INI_AKNGSocket();      


	while (!TermAKNGSoc){// recv send
//////////////////////////
	  NANOSON();
/////////////////////////
       qDebug("Wait for AKNG ");
		rc = recv( sakng,bufakng+totalr,CHR_MAX-totalr, NULL );
       // qDebug( "AKNG RECV rc" );

		if ( rc <= 0 ){//  ?
		  // printf( "AKNG RECV bad\n");
                          qDebug( "AKNG RECV bad");
                          DEINI_AKNGSocket();
		    INI_AKNGSocket();

				continue;
		}//else if rc==0
		else if ( rc > 0 ){ // ...- 
	  		totalr += rc; //  
			if ( totalr == CHR_MAX ){//     ...
		//		qDebug( "AKNG RECV good");
                 union
				{
				 unsigned char  b_char[CHR_MAX];
				 unsigned short buf[CHR_MAX/2];         
				_AKNG akng_asu;
                 }
				 UUU;
                 totalr=0;
				 unsigned long kurs=0;
				 double ZMR;

				 ZMR=360./2147483548;   //pow(2,31)/360;

				 memcpy(UUU.b_char,bufakng,CHR_MAX);
                 qDebug("AKNG1 /n ");
				 for(int i=0;i<(CHR_MAX/2);i++)
					  UUU.buf[i]=Swap(UUU.buf[i]);
					 // UUU.buf[i]=ntohs(UUU.buf[i]);
          //       qDebug("AKNG2 /n ");



				 _AKNG AKNG_ASU=UUU.akng_asu;  

				

				 unsigned long temp=(AKNG_ASU.Fi1 << 16) | AKNG_ASU.Fi2;
                 if(mgo==0)
				 {

					 lattitude=((signed long)temp)*ZMR;

					 temp=(AKNG_ASU.Lam1 << 16) | AKNG_ASU.Lam2;
					 longitude=((signed long)temp)*ZMR;
                     mgo=1;
                     sem_post(&sem_ksr);		
				 }
						
						}//if ( totalr == Akng_MAX )
			else
			 continue;
		}//if ( rc < 0 )

   
}//for send recv

	DEINI_AKNGSocket();
   pthread_exit(0); 	
} // end void server_14



